=== debian/changelog ===
blastem (0.6.2.1-1) unstable; urgency=medium

  * New upstream release
  * Fixed the FTBFS due to enabled hardening build flags

 -- Carlos Donizete Froes <coringao@riseup.net>  Mon, 11 Feb 2019 03:56:29 -0200

blastem (0.6.2-1) unstable; urgency=medium

  * Initial release (Closes: #919540)

 -- Carlos Donizete Froes <coringao@riseup.net>  Thu, 24 Jan 2019 03:08:50 -0200
