=== debian/control ===
Source: blastem
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Carlos Donizete Froes <coringao@riseup.net>
Build-Depends: debhelper (>= 12),
               libasound2-dev,
               libglew-dev,
               libsdl2-dev,
               libsdl2-mixer-dev,
               zlib1g-dev
Standards-Version: 4.3.0
Homepage: https://www.retrodev.com/blastem
Vcs-Browser: https://salsa.debian.org/games-team/blastem
Vcs-Git: https://salsa.debian.org/games-team/blastem.git

Package: blastem
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast and accurate Genesis emulator
 BlastEm is a highly precise multi-system emulator that emulates
 the Sega Genesis/Mega Drive, Master System and Game Gear.
 .
 Despite this high accuracy, even the most demanding software runs
 at full speed on modest hardware.
