=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	make HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
	DATA_PATH=/usr/share/games/blastem
