## blastem 0.6.3

=== Makefile ===
--- 
+++ 
@@ -193,7 +193,7 @@
 CFLAGS+=-DX86_32 -m32
 LDFLAGS+=-m32
 else
-$(error $(CPU) is not a supported architecture)
+# $(error $(CPU) is not a supported architecture)
 endif
 endif
