=== debian/changelog ===
blastem (0.6.3-1) unstable; urgency=medium

  * New upstream release

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 09 Mar 2019 22:10:42 -0300
