## blastem 0.6.3.2

=== debian/changelog ===
blastem (0.6.3.2-1) unstable; urgency=medium

  * New upstream release: 0.6.3.2

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 29 Jun 2019 12:08:17 -0300

blastem (0.6.3.1-1) unstable; urgency=medium

  * New upstream release (Closes: #926498)
  * Fix FTCBFS: (Thanks - Helmut Grohne)
    + Let dh_auto_build pass cross tools to make
  * Fixed spelling error in d/upstream/metadata

 -- Carlos Donizete Froes <coringao@riseup.net>  Fri, 28 Jun 2019 22:52:53 -0300
