=== debian/changelog ===
blastem (0.6.3.3-3) unstable; urgency=medium

  * Team upload.

  [ Reiner Herrmann ]
  * Fix FTBFS with GCC 10 (Closes: #957048)

  [ Markus Koschany ]
  * Declare compliance with Debian Policy 4.5.0.
  * Switch to debhelper-compat = 13.

 -- Markus Koschany <apo@debian.org>  Sun, 26 Jul 2020 14:37:00 +0200

blastem (0.6.3.3-2) unstable; urgency=medium

  * debian/control:
    + Bumped Standards-Version to 4.4.1.
    + Set Rules-Requires-Root to no.
  * debian/copyright:
    + Added copyright information for contact.
    + Official upstream link changed.

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 16 Nov 2019 03:26:12 -0300

blastem (0.6.3.3-1) unstable; urgency=medium

  * New upstream release: 0.6.3.3
  * Using new DH level format. Consequently:
    - debian/compat: removed.
    + debian/control: changed from 'debhelper' to 'debhelper-compat' in
      Build-Depends field and bumped level to 12.
  * debian/control:
    + Bumped Standards-Version to 4.4.0.

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 03 Aug 2019 01:00:15 -0300
