=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Carlos Donizete Froes <coringao@riseup.net>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
                libasound2-dev,
                libglew-dev,
                libsdl2-dev,
                libsdl2-mixer-dev,
                zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.retrodev.com/blastem
 Vcs-Browser: https://salsa.debian.org/games-team/blastem
 Vcs-Git: https://salsa.debian.org/games-team/blastem.git
