=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,5 @@
 	dh $@
 
 override_dh_auto_build:
-	make HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
+	dh_auto_build -- HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
 	DATA_PATH=/usr/share/games/blastem
