=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
  https://gitlab.com/coringao/blastem/tags \
  .*/blastem-(\d\S+)\.(?:tar\.(?:gz|bz2))
