=== debian/changelog ===
blastem (0.6.3.4-3) unstable; urgency=medium

  * Team Upload
  * Limit to architectures supported by upstream (Closes: #976494)

  [ Stéphane Blondon ]
  * re-add manpage as debian specific (Closes: #1037032)
  * Add synopsis section and reorder usage section

  [ Patrice Duroux ]
  * Update debian/watch. (Closes: #1089924)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 08 Feb 2025 18:04:20 +0100

blastem (0.6.3.4-2) unstable; urgency=medium

  * Team Upload.
  * upstream/metadata: remove extraneous tags

  [ Bernhard Übelacker ]
  * fix Segfault when trying to open rom or access system settings
    (Closes: #1054661)

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database.
  * Remove obsolete fields from debian/upstream/metadata
  * Update standards version to 4.6.2, no changes needed.

 -- Alexandre Detiste <tchet@debian.org>  Wed, 08 May 2024 18:57:23 +0200

blastem (0.6.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.6.3.4.
  * Declare compliance with Debian Policy 4.6.0.
  * Update debian/watch.
  * Drop gcc10.patch. Fixed upstream.
  * Fix FTCBFS: Pass CPU variable to make.
    Thanks to Helmut Grohne for the patch. (Closes: #956347)

 -- Markus Koschany <apo@debian.org>  Fri, 24 Sep 2021 22:14:33 +0200
