=== debian/control ===
--- 
+++ 
@@ -9,14 +9,14 @@
                libsdl2-dev,
                libsdl2-mixer-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.retrodev.com/blastem
 Vcs-Browser: https://salsa.debian.org/games-team/blastem
 Vcs-Git: https://salsa.debian.org/games-team/blastem.git
 
 Package: blastem
-Architecture: any
+Architecture: amd64 i386
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast and accurate Genesis emulator
  BlastEm is a highly precise multi-system emulator that emulates
