=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- HOST_ZLIB=1 CONFIG_PATH=/etc/blastem \
	CPU=$(DEB_HOST_GNU_CPU) \
	DATA_PATH=/usr/share/games/blastem

override_dh_auto_test:
	#FTBFS because of "undefined references"
