=== debian/watch ===
version=4
opts=searchmode=plain \
https://gitlab.com/coringao/blastem/tags?sort=updated_desc -/archive/[^/]+/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
